;(declare (unit abez))
(require-extension posix)
(require-extension srfi-1) ;; lists @_@
(require-extension srfi-13) ;; strings @_@
;(require-extension library)

(define-macro : (lambda x 
                  (define (colon-lambda-expander colon-exp)
                    (define colon ':)
                    (define exp (cdr (member colon colon-exp)))  ; exp | a b c -> a b c
                    (define arg-list (reverse (cdr (member colon (reverse colon-exp)))) )
                    (append (list 'lambda arg-list) exp)
                    )
                   (colon-lambda-expander x)))

;; (: x : (* x x))

(define (gen-range s n)
  (define (rec-gen-list k)
    (if (= k n)
        (list k)
        (cons k (rec-gen-list (+ k 1)))
        )
    )
  (rec-gen-list s)
)

(define (handle-each-line f)
  (do ((myLine (read-line) (read-line))) ;;init read-line then
      ((eof-object? myLine) '()) ;; do nothing
    (f myLine) ) )

  
    

;; e.g. (with-input-from-pipe (string-append "cat " file1) (lambda () (handle-each-line print)) #:text)

;; (define-macro λ (lambda x (append '(lambda) x)))
(define-macro λ (lambda x (cons 'lambda x)))
(define-macro λx (lambda z (append `(lambda (x)) z)))
(define-macro λ0 (lambda z (append `(lambda ()) z)))
(define-macro lambda0 (lambda z (append `(lambda ()) z)))
(define (lambda-macro-test)
  ((λx (print "lol")) "")
  ((λx (print x)) "lol")
  ((λ0 (print "lol")))
  ((λ () (print "lol")))
)

(define-macro let-values (lambda (x y z) (print x) (print y) (print z)))
(define-macro let-values (lambda (x y z)
                           `(call-with-values (lambda () ,x)
                              (lambda ,y ,z))))

(define (split-white-space s)
  (string-tokenize s))
(define split-whitespace split-white-space)
(define (split-semi-colon s)
  (string-split s ";"))
(define (split-colon s)
  (string-split s ":"))
(define (split-first-colon s)
  (let ((i (string-index s #\:)))
    (if (integer? i) (list (substring s 0 i) (substring s (+ i 1))) (list s))))

(define (whitespace? c)
  (cond ((char=? #\space c) #t)
        ((char=? #\tab   c) #t)
        ((char=? #\newline   c) #t)
        (else #f)
        )
)
;; a more effecient one would count the head and tail of the string then substring it
(define (trim s)
  (define sl (string->list s))
  ;; chomp head off
  (define (delw sl)
    (cond ((null? sl) '())
	  ((whitespace? (car sl)) (delw (cdr sl)))
	  (else sl)))
  (list->string (reverse (delw (reverse (delw sl)))))
)
;; (trim "      lol     ")

(define (concat-til do-this until-this)
  (let ((x (do-this)))
    (if (until-this x) '() (cons x (concat-til do-this until-this)))))

(define (concat-til-inclusive do-this until-this)
  (let ((x (do-this)))
    (if (until-this x) (begin (list x))  (cons x (concat-til-inclusive do-this until-this)))))

(define (concat-til-inclusive-ignore-false do-this until-this)
  (let ((x (do-this)))
    (cond
     ((not x) (concat-til-inclusive do-this until-this))
     ((until-this x) (begin (list x)))
     (else (cons x (concat-til-inclusive do-this until-this))))))

;; this one ignores false
(define (concat-til-inclusive-or-false do-this until-this)
  (let ((x (do-this)))
    (cond
     ((not x) '())
     ((until-this x) (begin (list x)))
     (else (cons x (concat-til-inclusive do-this until-this))))))


;  (define (catch-and-return-false thunk)
;   (condition-case (thunk)
;     [(exn file) (error "file error")]
;     [(exn) (begin (print "other error") #f)]
;     [var () (error "something else")] ) )

; (call/cc

; (define (concat-til-inclusive-or-exceptions do-this until-this)
;   (catch-and-return-false (let ((x (do-this)))
;                     (if (until-this x) (begin (list x))  (cons x (concat-til-inclusive do-this until-this))))))



;;(concat-til-inclusive (lambda () (random 10)) (lambda (x) (> x 7)))

;;(define-macro shift! (lambda (x) `(if (null? ,x) #f (let ((o (car ,x))) (set! ,x (cdr ,x)) (list o)))))

;;(define-macro pop! (lambda (x) `(if (null? ,x) #f (let* ((r (reverse ,x)) (o (car r))) (set! ,x (reverse (cdr r))) (list o)))))

;;(define-macro push! (lambda (x y) `(begin (set! ,x (append ,x (list ,y))) ,y)))

;;(define-macro unshift! (lambda (x y) `(begin (set! ,x (cons ,y ,x)) ,y)))


(define-macro pop!
  (lambda (x) 
    `(if (null? ,x) #f
         (let ((r (reverse ,x)))
           (let ((k (car r)))
             (set! ,x (reverse (cdr r)))
             k)))))

(define-macro push!
  (lambda (x y) `(set! ,x (reverse (cons ,y (reverse ,x))))))

(define-macro unshift!
  (lambda (x y) `(set! ,x (cons ,y ,x))))

(define-macro shift! (lambda (x) `(if (null? ,x) #f (let ((k (car ,x))) (set! ,x (cdr ,x)) k))))



(define (test-shift!-pop!) 
  (define ll '())
 ;; (map (lambda (x) (display (eval x)))
       ;;`(
  (map (lambda (x) (print (x))) (list
             (lambda0 (push! ll "I'm"))
             (lambda0 (push! ll "a"))
             (lambda0 (push! ll "big"))
             (lambda0 (push! ll "homo"))
             (lambda0 (pop!  ll))
             (lambda0 (pop!  ll))
             (lambda0 (pop!  ll))
             (lambda0 (pop!  ll))
             (lambda0 (pop!  ll))
             (lambda0 (unshift! ll "Homo"))
             (lambda0 (unshift! ll "big"))
             (lambda0 (unshift! ll "a"))
             (lambda0 (unshift! ll "I'm"))
             (lambda0 (shift!  ll))
             (lambda0 (shift!  ll))
             (lambda0 (shift!  ll))
             (lambda0 (shift!  ll))
             (lambda0 (shift!  ll))
             )
       )
  (define kkk '(1 2 3 4 5 6 7 8 9 10))
  (do ((i (shift! kkk) (shift! kkk)))
      ((not i) 'done)
    (print i))
)

(define (read-line-like-iter l)
  (define finished ':abez-finished:)
  (letrec ((ll l)
        (iterator (lambda ()
                    (if (null? ll) finished
                        (let ((old (car ll))
                              (new (cdr ll)))
                          (set! ll new) old))))
        (eof? (lambda (x) (eq? x finished))))
    (list iterator eof?)))


(define (test-read-line-like-iter)
  (let* ((l '( 1 2 3 4 5 6 ))
         (rle (read-line-like-iter l))
         (rl (first rle))
         (eof? (second rle))
         )

    
    (do ((i (rl) (rl)))
        ((eof? i) (begin (print "Finished") i))
      (print i))))
         

(define assert (lambda (exp . other)
                 (define out (if (null? other) "ASSERTION FAILED" other))
                 (if (exp) exp (error out))))
(define assert>0 (lambda (a . other)
                    (assert (> a 0) other)))
(define assert-binary (lambda (f a b . other)
                    (assert (f a b) other)))
(define assert-streq? (lambda (a b . other) (assert-binary string=? a b other)))
(define assert-eq? (lambda (a b . other) (assert-binary eq? a b other)))


(define (if-pass f exp else)
  (if (f exp) exp else))
(define (unless-pass f exp else)
  (if (not (f exp)) exp else))

(define (foldi f init l)
  (let foldir ((init init) (index 0) (l l))
    (if (null? l) init
        (foldir (f index (car l) init) (+ index 1) (cdr l)))))

(define (test-foldi)
  (print (foldi (lambda (i x y) (print (list i x y)) (+ x y)) 0 '(1 2 3 4 5 6)))
  (print (foldi (lambda (i x y) (cons i (cons x y))) '() '(1 2 3 4 5 6))))

(define (iteri f l)
  (let loop ((l l) (i 0))
    (if (pair? l)(begin
                   (f i (car l))
                   (loop (cdr l) (+ i 1)))
        #f)))

(define (mapi f l)
  (let loop ((l l) (i 0))
    (if (null? l) '()
        (cons (f i (car l)) (loop (cdr l) (+ i 1) )))))

(define (mapi f l)
  (define index 0)
  (define fi (lambda (x)
              (let ((ret (f index x)))
                (set! index (+ 1 index))
                ret)))
  (map fi l))


(define (test-mapi-iteri)
  (iteri (lambda (i x) (print i) (print x)) '( 1 2 3 4 5 6))
  (mapi (lambda (i x) (print i) (print x) (list i x)) '( 1 2 3 4 5 6)))

(define (ntimes f i)
  (if (= i 1) (f)
      (begin (f) (ntimes f (- i 1)))))

(define-macro return-first (lambda (x . l)
                             `(let ((return ,x))
                               ,(append '(begin) l)
                               return)))

(define (test-return-first l) (return-first (car l) (set! l (cdr l))))

(define (expand-vector v size dfl) 
  (let ((l (vector-length v)))
    (if (> l size) v
        (let ((newvec (make-vector size dfl)))
          (vector-copy! v newvec)
          newvec))))

(define (vector-add! v i x)
  (vector-set! v i (+ (vector-ref v i) x)))

(define (file-fold f init file) ; f is (lambda (line old) )
  (with-input-from-file file 
    (lambda ()
      (let ((rl (lambda () (let ((line (read-line)))
                             (if (eof-object? line) #f line)))))
        (let loop ((line (rl)) (o init))
                 (if line (loop (rl) (f line o)) o))))))

(define (read-line-map f)
  (let ((rl (lambda () (let ((line (read-line)))
                         (if (eof-object? line) #f line)))))
    (let loop ((line (rl)))
      (if line (cons (f line) (loop (rl))) '()))))

(define (file-line-map f file) ; f is (lambda (line old) )
  (with-input-from-file file 
    (lambda () (read-line-map f))))


(define (file-read-all-lines file)
  (file-line-map (lambda (x) x) file))

(define (read-all-lines)
  (read-line-map (lambda (x) x)))
;; FAILURE
;; SOLUTION -
;;    if we have a string then return that string queue up newline
;; READ TO \n NOT \r
; (define (gen-read-newline)
;   (define nl #\newline)
;   (define eof #!eof)
;   (define currf #f)
;   (define (return-eof) (set! currf read-til-newline) eof)
;   (define (read-til-newline-rec)
;     (let ((char (read-char)))
;       (cond
;        ((eof-object? char) (set! currf return-eof) '())
;        ((char=? char #\newline) '())
;        (else (cons char (read-til-newline-rec))))))
;   (define (read-til-newline)
;     (let ((l (read-til-newline-rec)))
;       (if (eof-object? l) l (list->string l))))
;   (set! currf read-til-newline)
;   (lambda () (currf)))

; (define read-newline (gen-read-newline))
  
(define (read-newline)
  (define (loop)
    (let ((char (read-char)))
      (cond
       ((eof-object? char) char)
       ((char=? char #\newline) '())
       ((eof-object? (peek-char)) (list char))
       (else (cons char (loop))))))
  (let ((o (loop)))
    (if (eof-object? o) o (list->string o))))

; (with-input-from-file "carriage-return" (lambda () (do ((line (read-newline) (read-newline))) ((eof-object? line) 'done) (print line))))
(define s+ string-append)
(define (to-int x)(inexact->exact (round x)))
(define (flatten-once l)
  (fold append '() l))




(define-macro begin-my
  (let ((ismy? (lambda (x) (and (pair? x) (eqv? 'my (car x))))))
    (lambda x
       (let loop ((l x))
	 (if (pair? l)
	     (let ((head (car l)))
	       (if (ismy? head) 
		   (list 'let 
			 (list (list (cadr head) (caddr head)))  
			 (loop (cdr l)))
		   (if (pair? (cdr l))
		       (list 'begin (car l) (loop (cdr l)))
		       (list 'begin (car l))))))))))

	

(define (begin-my-test)
  (begin-my
   (my a 99)
   (my b 2)
   (set! a (+ a b));103
   (print a)
   (set! a (+ a b));105
   (print a)
   (my c 3)
   (my a (+ a c))
   (print a)
   a))

(define (ENV x) (cdr (assoc x (current-environment))))
; get the perl argv (that is all the args except the name
(define (perl-argv) 
  (let ((args (argv)))
    (if (and (pair? args) (string=? "csi" (pathname-file (car args)))) ; run from interpretter
        (cddr args)
        (cdr args))))

(define (list->cons l) (cons (car l) (cadr l)))

;; utils
  
; This trims too
(define j+ (lambda x (string-join x " ")))
(define (slurp-file file)
  (with-input-from-file file read-all-lines))
(define (slurp-system command)
  (with-input-from-pipe command read-all-lines))
(define (slurp-system->number cmd)
    (string->number (car (slurp-system cmd))))

(define (slurp-file->number cmd)
    (string->number (car (slurp-file cmd))))

(define (slurp-file->numbers cmd)
    (map string->number (slurp-file cmd)))


(define (slurp-system->lists cmd delimiter)
  (let ((lines (slurp-system cmd)))
    (map (lambda (x) (map trim (string-split x delimiter))) lines)))

(define (map-col f col-number list-of-lists)
  (map (lambda (l)
         (receive (front back)
             (split-at l (max 0 (- col-number 1)))
           (append front (list (f (car back))) (cdr back))))
       list-of-lists))

(define (assoc-map-val f l)
  (map (lambda (x)
         (cons (car x) (f (cdr x)))) l))
(define (assoc-map-key f l)
  (map (lambda (x)
         (cons (car x) (f (car x)))) l))
(define (assoc-map-key-val f l)
  (map (lambda (x)
         (cons (car x) (f (car x) (cdr x)))) l))



(define (map-cdr f l)
  (map (lambda (x) (f (cdr x))) l))
(define (map-car f l)
  (map (lambda (x) (f (car x))) l))
(define (ret-zero) 0 )

; this is used in sorting assoc
(define (cdr-cmp f)
  (lambda (x y) (f (cdr x) (cdr y))))

(define lambda-null (lambda () '()))
(define (list->assoc l) (map list->cons l))

(define (dump-to-csv filename table delimiter)
  (with-output-to-file filename 
    (lambda ()
      (for-each (lambda (line)
                  (print (string-join (map ->string line) delimiter)))
                table))))

; (mapn even? (list (list 1 2 3 4 5) (list 2 4 6 8 10) (list 1 3 5 7 9) (list 0 0 0 1 1)))
; 25> ((#f #t #f #t) (#t #t #f #t) (#f #t #f #t) (#t #t #f #f) (#f #t #f #f))
(define mapn 
  (lambda (f  l)
    (let loop ((lists l))
      (if (every pair? lists)
          (let* ((cars (map car lists))
                 (cdrs (map cdr lists))
                 (new-cars (map f cars)))
            (cons new-cars (loop cdrs)))
          '()))))

;like assoc but with a default value (cons key dfl)
(define (assoc-dfl key list dfl)
  ((lambda (x) (if (not x) (cons key dfl) x))
   (assoc key list)))

; convert the keys of a assoc list to indices (make an assoc list)
(define (assoc-indices alist)   
  (let ((i 0))
    (assoc-map-val (lambda (x) 
                     (dynamic-wind lambda-null (lambda () i) (lambda () (set! i (+ i 1)))))
                   alist)))


(define (car-cdr-lambda f) (lambda (x) (f (car x) (cdr x))))
(define (car-cadr-lambda f) (lambda (x) (f (car x) (cadr x))))
(define (dump-list-to-file file l)
  (with-output-to-file file (lambda ()
                         (for-each print l))))

(define file:basename pathname-strip-directory)

(define (file-list-possibly-from-stdin file-list)
  (if (not (pair? file-list))
      (error "Not a list!"))
  (if (string=? "-" (car file-list))
      (read-all-lines)
      file-list))
